/*
 * DO NOT EDIT.  THIS FILE IS GENERATED FROM ../../../dist/idl/nsICertBlocklist.idl
 */

#ifndef __gen_nsICertBlocklist_h__
#define __gen_nsICertBlocklist_h__


#ifndef __gen_nsISupports_h__
#include "nsISupports.h"
#endif

/* For IDL files that don't want to include root IDL files. */
#ifndef NS_NO_VTABLE
#define NS_NO_VTABLE
#endif
class nsIX509Cert; /* forward declaration */

#define NS_CERTBLOCKLIST_CONTRACTID "@mozilla.org/security/certblocklist;1"

/* starting interface:    nsICertBlocklist */
#define NS_ICERTBLOCKLIST_IID_STR "44b0ee42-1af3-45e7-b601-7f17bd67c5cc"

#define NS_ICERTBLOCKLIST_IID \
  {0x44b0ee42, 0x1af3, 0x45e7, \
    { 0xb6, 0x01, 0x7f, 0x17, 0xbd, 0x67, 0xc5, 0xcc }}

class NS_NO_VTABLE nsICertBlocklist : public nsISupports {
 public: 

  NS_DECLARE_STATIC_IID_ACCESSOR(NS_ICERTBLOCKLIST_IID)

  /* void addRevokedCert (in string issuer, in string serialNumber); */
  NS_IMETHOD AddRevokedCert(const char * issuer, const char * serialNumber) = 0;

  /* void saveEntries (); */
  NS_IMETHOD SaveEntries(void) = 0;

  /* boolean isCertRevoked ([array, size_is (issuer_length), const] in octet issuer, in unsigned long issuer_length, [array, size_is (serial_length), const] in octet serial, in unsigned long serial_length); */
  NS_IMETHOD IsCertRevoked(const uint8_t *issuer, uint32_t issuer_length, const uint8_t *serial, uint32_t serial_length, bool *_retval) = 0;

};

  NS_DEFINE_STATIC_IID_ACCESSOR(nsICertBlocklist, NS_ICERTBLOCKLIST_IID)

/* Use this macro when declaring classes that implement this interface. */
#define NS_DECL_NSICERTBLOCKLIST \
  NS_IMETHOD AddRevokedCert(const char * issuer, const char * serialNumber) override; \
  NS_IMETHOD SaveEntries(void) override; \
  NS_IMETHOD IsCertRevoked(const uint8_t *issuer, uint32_t issuer_length, const uint8_t *serial, uint32_t serial_length, bool *_retval) override; 

/* Use this macro to declare functions that forward the behavior of this interface to another object. */
#define NS_FORWARD_NSICERTBLOCKLIST(_to) \
  NS_IMETHOD AddRevokedCert(const char * issuer, const char * serialNumber) override { return _to AddRevokedCert(issuer, serialNumber); } \
  NS_IMETHOD SaveEntries(void) override { return _to SaveEntries(); } \
  NS_IMETHOD IsCertRevoked(const uint8_t *issuer, uint32_t issuer_length, const uint8_t *serial, uint32_t serial_length, bool *_retval) override { return _to IsCertRevoked(issuer, issuer_length, serial, serial_length, _retval); } 

/* Use this macro to declare functions that forward the behavior of this interface to another object in a safe way. */
#define NS_FORWARD_SAFE_NSICERTBLOCKLIST(_to) \
  NS_IMETHOD AddRevokedCert(const char * issuer, const char * serialNumber) override { return !_to ? NS_ERROR_NULL_POINTER : _to->AddRevokedCert(issuer, serialNumber); } \
  NS_IMETHOD SaveEntries(void) override { return !_to ? NS_ERROR_NULL_POINTER : _to->SaveEntries(); } \
  NS_IMETHOD IsCertRevoked(const uint8_t *issuer, uint32_t issuer_length, const uint8_t *serial, uint32_t serial_length, bool *_retval) override { return !_to ? NS_ERROR_NULL_POINTER : _to->IsCertRevoked(issuer, issuer_length, serial, serial_length, _retval); } 

#if 0
/* Use the code below as a template for the implementation class for this interface. */

/* Header file */
class nsCertBlocklist : public nsICertBlocklist
{
public:
  NS_DECL_ISUPPORTS
  NS_DECL_NSICERTBLOCKLIST

  nsCertBlocklist();

private:
  ~nsCertBlocklist();

protected:
  /* additional members */
};

/* Implementation file */
NS_IMPL_ISUPPORTS(nsCertBlocklist, nsICertBlocklist)

nsCertBlocklist::nsCertBlocklist()
{
  /* member initializers and constructor code */
}

nsCertBlocklist::~nsCertBlocklist()
{
  /* destructor code */
}

/* void addRevokedCert (in string issuer, in string serialNumber); */
NS_IMETHODIMP nsCertBlocklist::AddRevokedCert(const char * issuer, const char * serialNumber)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* void saveEntries (); */
NS_IMETHODIMP nsCertBlocklist::SaveEntries()
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* boolean isCertRevoked ([array, size_is (issuer_length), const] in octet issuer, in unsigned long issuer_length, [array, size_is (serial_length), const] in octet serial, in unsigned long serial_length); */
NS_IMETHODIMP nsCertBlocklist::IsCertRevoked(const uint8_t *issuer, uint32_t issuer_length, const uint8_t *serial, uint32_t serial_length, bool *_retval)
{
    return NS_ERROR_NOT_IMPLEMENTED;
}

/* End of implementation class template. */
#endif


#endif /* __gen_nsICertBlocklist_h__ */
